local GlobalAddonName = ...

local VERSION = "2.5"
local VERSION_NUMERIC = 25

local ToDoFunc = {}

_G.LegionToDo = {
	ToDoFunc = ToDoFunc,
}

local coinsQuests = UnitLevel'player' <= 100 and {[36058]=1,[36055]=1,[37452]=1,[37453]=1,[36056]=1,[37457]=1,[37456]=1,[36054]=1,[37455]=1,[37454]=1,[36057]=1,[37458]=1,[37459]=1,[36060]=1,} or
	{[43895]=1,[43897]=1,[43896]=1,[43892]=1,[43893]=1,[43894]=1,[43510]=1,}
local coinsCurrency = UnitLevel'player' <= 100 and 1129 or 1273
	
tinsert(ToDoFunc,function(self,collect)
	local count = 0
	for id,_ in pairs(coinsQuests) do
		if IsQuestFlaggedCompleted(id) then
			count = count + 1
		end
	end
	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(coinsCurrency)
	
	local coinsStr = format("|cff%s%d/%d [%d%s]",count==3 and "00ff00" or (totalMax == amount and isDiscovered) and "ff8000" or "ff0000",count,3,amount or 0,totalMax == amount and isDiscovered and ",cap" or "")
	self:AddDoubleLine("Coins", coinsStr,1,1,1)
	self:AddTexture("Interface/Icons/inv_misc_elvencoins")
	
	collect.coins = coinsStr
	collect.coinsNow = amount
	collect.coinsMax = totalMax
	collect.coinsWeek = count
	
	if UnitAura("player",GetSpellInfo(239967),nil) then
		count = 0
		for _,id in pairs({47038,47044,47053}) do
			if IsQuestFlaggedCompleted(id) then
				count = count + 1
			end
		end
		self:AddDoubleLine("Bonus coins", count,1,1,1)
	end
end)

tinsert(ToDoFunc,function(self,collect)
	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1220)
	self:AddDoubleLine(name, amount, 1,1,1)
	self:AddTexture("Interface/Icons/inv_orderhall_orderresources")
	
	collect.hallres = amount
	
	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1342)
	self:AddDoubleLine(name, amount, 1,1,1)
	self:AddTexture("Interface/Icons/inv_misc_summonable_boss_token")
	
	collect.warsuppl = amount
	
	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1226)
	self:AddDoubleLine(name, amount, 1,1,1)
	self:AddTexture("Interface/Icons/inv_datacrystal01")
	
	collect.nethershard = amount	

	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1508)
	if name and name ~= "" then
		self:AddDoubleLine(name, amount, 1,1,1)
		self:AddTexture("Interface/Icons/oshugun_crystalfragments")	
		
		collect.argunite = amount	
	end
end)

local days3val = 3 * 24 * 60 * 60
local days1val = 24 * 60 * 60
local witheredTrainingDay0 = 1468994400 + days1val * 2

tinsert(ToDoFunc,function(self,collect)
	local name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1155)
	local amanaStr = format("|cff%s%d/%d",amount==totalMax and "00ff00" or amount >=1300 and "ff8000" or "ff0000",amount,totalMax)
	self:AddDoubleLine(name, amanaStr,1,1,1)
	self:AddTexture("Interface/Icons/inv_misc_ancient_mana")
	
	collect.amana = amanaStr
	collect.amanaNow = amount
	collect.amanaMax = totalMax

	local isDone = IsQuestFlaggedCompleted(43943)
	--self:AddDoubleLine("Withered Army Training:", isDone and "|cff00ff00Done" or "|cffff0000Not completed",1,1,1)
	
	local diff = days3val - ((time() - witheredTrainingDay0) % days3val)

	local strDiff = format("%dh %dm",(diff / 3600) % 24,(diff / 60) % 60)
	if diff >= days1val then
		strDiff = floor(diff / days1val).."d "..strDiff
	end

	--self:AddDoubleLine("         Reset in",strDiff,1,1,1)
	
	collect.wtraining = isDone
	collect.wtrainingweek = floor((time() - witheredTrainingDay0) / days3val)
end)

tinsert(ToDoFunc,function(self,collect)
	local arguniteQuest = IsQuestFlaggedCompleted(48799)

	if not arguniteQuest then
		local isInLog = GetQuestLogIndexByID(48799)
		if isInLog and isInLog ~= 0 then
			local objectiveText, objectiveType, finished, numFulfilled, numRequired = GetQuestObjectiveInfo(48799, 1, false)
			if numFulfilled and numRequired then
				collect.arguniteQuest = numFulfilled .. "/" .. numRequired		
				self:AddDoubleLine("Argunite Quest:",collect.arguniteQuest,1,1,1)
			end
		else
			collect.arguniteQuest = nil
		end
	else
		self:AddDoubleLine("Argunite Quest:","|cff00ff00Done",1,1,1)
		collect.arguniteQuest = true
	end

	local recruitLvl1 = IsQuestFlaggedCompleted(48910)
	local recruitLvl2 = IsQuestFlaggedCompleted(48911)
	local recruitLvl3 = IsQuestFlaggedCompleted(48912)
	
	self:AddDoubleLine("Argus recruits:", (recruitLvl1 and "|cff00ff00+|r" or "|cffff0000-|r").."/"..(recruitLvl2 and "|cff00ff00+|r" or "|cffff0000-|r").."/"..(recruitLvl3 and "|cff00ff00+|r" or "|cffff0000-|r"),1,1,1)
end)

--[[
tinsert(ToDoFunc,function(self,collect)
	C_Garrison.RequestLandingPageShipmentInfo()

	--if select(2,GetCurrencyInfo(1171)) == 25 then
	--end

	local researchID = 186
	local looseShipments = C_Garrison.GetLooseShipments(3)
	for i = 1, #looseShipments do
		local name, texture = C_Garrison.GetLandingPageShipmentInfoByContainerID(looseShipments[i])
		if texture == 237446 then
			researchID = looseShipments[i]
			break
		end
	end
	local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString = C_Garrison.GetLandingPageShipmentInfoByContainerID(researchID)
	if not name or shipmentsTotal == shipmentsReady then
		self:AddDoubleLine("Artifact research", "Not started", 1,0,0,1,0,0)
		self:AddTexture("Interface/Icons/INV_Scroll_11")
		return
	end
	self:AddDoubleLine(name, format("%d/%d",shipmentsReady,shipmentsTotal), 1,1,1,0,1,0)
	self:AddTexture("Interface/Icons/INV_Scroll_11")
	
	local t = (creationTime + duration - time()) + max(0,shipmentsTotal - shipmentsReady - 1) * duration
	
	local strT = format("%dh %dm",(t / 3600) % 24,(t / 60) % 60)
	if t >= days1val then
		strT = floor(t / days1val).."d "..strT
	end
	
	self:AddDoubleLine("         Ended in",strT,1,1,1)
	if shipmentsTotal > 0 and shipmentsTotal ~= shipmentsReady then
		self:AddDoubleLine("         next at",date("%d.%m.%Y %H:%M",creationTime + duration),1,1,1)
	end
	
	collect.research = creationTime + duration + max(0,shipmentsTotal - shipmentsReady - 1) * duration
end)
]]

tinsert(ToDoFunc,function(self,collect)
	self:AddDoubleLine("Blingtron 6000", IsQuestFlaggedCompleted(40753) and "|cff00ff00Done" or "|cffff0000Not completed", 1,1,1)
end)


local garrison_mission_rewards = {
	[140171] = "mission_nh",
	[140174] = "mission_nh",
	[140178] = "mission_nh",
	[140181] = "mission_nh",
	[140147] = "mission_nh",
	[140151] = "mission_nh",
	[140149] = "mission_nh",
	[140153] = "mission_nh",
	[140180] = "mission_nh",
	[140173] = "mission_nh",
	[140177] = "mission_nh",
	[140183] = "mission_nh",
	[140472] = "mission_nh",
	[140172] = "mission_nh",
	[140175] = "mission_nh",
	[140182] = "mission_nh",
	
	[140163] = "mission_en",
	[140165] = "mission_en",
	[140167] = "mission_en",
	[140169] = "mission_en",
	[139480] = "mission_en",
	[139481] = "mission_en",
	[139482] = "mission_en",
	[139483] = "mission_en",
	[140164] = "mission_en",
	[140166] = "mission_en",
	[140168] = "mission_en",
	[140170] = "mission_en",

	[147497] = "mission_tos",
	[147498] = "mission_tos",
	[147499] = "mission_tos",
	[147500] = "mission_tos",
	[147501] = "mission_tos",
	[147502] = "mission_tos",
	[147503] = "mission_tos",
	[147504] = "mission_tos",
	[147505] = "mission_tos",
	[147506] = "mission_tos",
	[147507] = "mission_tos",
	[147508] = "mission_tos",
	[147509] = "mission_tos",
	[147510] = "mission_tos",
	[147511] = "mission_tos",
	[147512] = "mission_tos",
	
	[139479] = "mission_5ppl_amk",
	[141185] = "mission_5ppl_amk",
	[141186] = "mission_5ppl_amk",
	
	[139478] = "mission_5ppl_kaze",
	[141187] = "mission_5ppl_kaze",
	[141188] = "mission_5ppl_kaze",
	
	[139476] = "mission_5ppl_nelt",
	[141191] = "mission_5ppl_nelt",
	[141192] = "mission_5ppl_nelt",

	[139474] = "mission_5ppl_eye",
	[141197] = "mission_5ppl_eye",
	[141198] = "mission_5ppl_eye",

	[139475] = "mission_5ppl_maw",
	[141193] = "mission_5ppl_maw",
	[141194] = "mission_5ppl_maw",

	[139473] = "mission_5ppl_dht",
	[141199] = "mission_5ppl_dht",
	[141200] = "mission_5ppl_dht",

	[139457] = "mission_5ppl_halls",
	[141195] = "mission_5ppl_halls",
	[141196] = "mission_5ppl_halls",

	[139471] = "mission_5ppl_brh",
	[141203] = "mission_5ppl_brh",
	[141204] = "mission_5ppl_brh",

	[139477] = "mission_5ppl_suramar",
	[141190] = "mission_5ppl_suramar",

	[139472] = "mission_5ppl_cos",
	[141202] = "mission_5ppl_cos",

	[142340] = "mission_5ppl_kara",	
	
	[152313] = "mission_abt",
	[152314] = "mission_abt",
	[152315] = "mission_abt",
	[152316] = "mission_abt",
	[152317] = "mission_abt",
	[152318] = "mission_abt",
	[152319] = "mission_abt",
	[152320] = "mission_abt",
	[152321] = "mission_abt",
	[152322] = "mission_abt",
	[152323] = "mission_abt",
	[152324] = "mission_abt",
	[152325] = "mission_abt",
	[152326] = "mission_abt",
	[152327] = "mission_abt",
	[152328] = "mission_abt",
	
}

tinsert(ToDoFunc,function(self,collect)
	local curr = time()
	
	local active_en, active_nh, active_tos, active_abt
	
	local currentMissions = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_GARRISON_7_0)
	
	if currentMissions then
		for i=1,#currentMissions do
			local rewards = currentMissions[i].rewards
			
			if rewards then
				for j=1,#rewards do
					if rewards[j].itemID then
						local missionType = garrison_mission_rewards[ rewards[j].itemID ]
						if missionType then
							if currentMissions[i].offerEndTime then
								collect.s[missionType] = currentMissions[i].offerEndTime - GetTime() + curr - 10 * 24 * 60 * 60
							end
							if missionType == "mission_en" then
								active_en = true
							elseif missionType == "mission_nh" then
								active_nh = true
							elseif missionType == "mission_tos" then
								--collect.s[missionType] = collect.s[missionType] + 7 * 24 * 60 * 60
								active_tos = true
							elseif missionType == "mission_abt" then
								active_abt = true
							elseif missionType:find("5ppl") then
								collect.s[missionType] = collect.s[missionType] + 7 * 24 * 60 * 60
							end
							break
						end
					end 
				
				end
			end
		end
	end
	
	local mission_en = collect.s.mission_en
	if mission_en then
		while mission_en < curr do
			mission_en = mission_en + (13 * 24 * 60 * 60)
		end
	
		--self:AddDoubleLine("EN Garrison Mission", date("%d.%m.%Y %H:%M",mission_en), 1,1,1,active_en and 0 or 1,1,active_en and 0 or 1)
	end
	
	local mission_nh = collect.s.mission_nh
	if mission_nh then
		while mission_nh < curr do
			mission_nh = mission_nh + (13 * 24 * 60 * 60)
		end
	
		--self:AddDoubleLine("NH Garrison Mission", date("%d.%m.%Y %H:%M",mission_nh), 1,1,1,active_nh and 0 or 1,1,active_nh and 0 or 1)
	end
	
	local mission_tos = collect.s.mission_tos
	if mission_tos then
		while mission_tos < curr do
			mission_tos = mission_tos + (13 * 24 * 60 * 60)
		end
	
		self:AddDoubleLine("ToS Garrison Mission", date("%d.%m.%Y %H:%M",mission_tos), 1,1,1,active_tos and 0 or 1,1,active_tos and 0 or 1)
	end
	
	local mission_abt = collect.s.mission_abt
	if mission_abt then
		while mission_abt < curr do
			mission_abt = mission_abt + (13 * 24 * 60 * 60)
		end
	
		self:AddDoubleLine("ABT Garrison Mission", date("%d.%m.%Y %H:%M",mission_abt), 1,1,1,active_abt and 0 or 1,1,active_abt and 0 or 1)
	end
	
	--[[
	for missionType,missionTime in pairs(collect.s) do
		if type(missionType)=='string' and missionType:find("5ppl") then
			self:AddDoubleLine(missionType, date("%d.%m.%Y %H:%M",missionTime), 1,1,1,1,1,1)
		end
	end
	]]
end)


local instances = {
	707,740,767,716,727,762,721,777,726,800,860,900,945,
}
local instancesInOptions = {
	1,2,3,4,5,6,7,8,9,10,11,12,13,
}
local instancesLastBoss = {
	
}
local instancesAttune = {
	--[10] = 44053,
	--[9] = 44053,
}


for i=1,#instances do
	instances[i] = EJ_GetInstanceInfo(instances[i])
end

local function IsInArray(arr,subj)
	for i=1,#arr do
		if arr[i]==subj then
			return i
		end
	end
end

tinsert(ToDoFunc,function(self,collect)
	local res = {}
	for i=1,GetNumSavedInstances() do
		local instanceName, instanceID, instanceReset, instanceDifficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName, totalBosses, defeatedBosses = GetSavedInstanceInfo(i)
	
		if instanceDifficulty == 23 then
			local inArr = IsInArray(instances,instanceName)
			if inArr then
				defeatedBosses = locked and defeatedBosses or 0
				
				local _,_,lastBossDefeated = GetSavedInstanceEncounterInfo(i, instancesLastBoss[i] or totalBosses)
				if defeatedBosses == 0 and lastBossDefeated then
					lastBossDefeated = false
				end
				
				res[inArr] = format("|cff%s%d/%d",totalBosses==defeatedBosses and "00ff00" or lastBossDefeated and "ffff00" or "ff0000",defeatedBosses,totalBosses)
			end
		end
	end
	self:AddLine("Mythic:")
	for i=1,#instances do
		
		if instancesAttune[i] and not res[i] and not IsQuestFlaggedCompleted(instancesAttune[i]) then
			self:AddDoubleLine(instances[i], "|cffff0000Locked",1,1,1)
			collect["instance"..i] = "|cffff0000Locked"
		else
			self:AddDoubleLine(instances[i], res[i] or "|cffff0000---",1,1,1)
			collect["instance"..i] = res[i] or "|cffff0000---"
		end
	end
end)


local mythicPlusMaps = C_ChallengeMode.GetMapTable()
tinsert(ToDoFunc,function(self,collect)
	C_ChallengeMode.RequestMapInfo()
	C_ChallengeMode.RequestRewards()
	local max = 0
	for i=1,#mythicPlusMaps do
		local _, _, level, affixes = C_ChallengeMode.GetMapPlayerStats(mythicPlusMaps[i])
		if level and level > max then
			max = level
		end
	end
	self:AddDoubleLine("Weekly max mythic+", max,1,1,1)
	collect["weeklymax"] = max	
end)


local raids = {
	768,861,786,875,946,
}
local raids_max_bosses = {
	7,3,10,9,11,
}
local raids_short_format = {
	true,true,true,false,false,
}

for i=1,#raids do
	raids[i] = EJ_GetInstanceInfo(raids[i])
end
local raidsDiffs = {
	14,15,16,
}
local raidsDiffsNames = {
	PLAYER_DIFFICULTY1,PLAYER_DIFFICULTY2,PLAYER_DIFFICULTY6,
}

tinsert(ToDoFunc,function(self,collect)
	local res = {}
	for i=1,GetNumSavedInstances() do
		local instanceName, instanceID, instanceReset, instanceDifficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName, totalBosses, defeatedBosses = GetSavedInstanceInfo(i)
	
		if instanceDifficulty and IsInArray(raidsDiffs,instanceDifficulty) then
			local inArr = IsInArray(raids,instanceName)
			if inArr then
				defeatedBosses = (locked or extended) and defeatedBosses or 0
								
				res[inArr] = res[inArr] or {}
				res[inArr][instanceDifficulty] = defeatedBosses
			end
		end
	end
	
	self:AddLine("Raids:")
	for i=1,#raids do
		for j=1,#raidsDiffs do
			if res[i] and res[i][ raidsDiffs[j] ] then
				self:AddDoubleLine(raids[i].." "..raidsDiffsNames[j], format("|cff%s%d/%d",raids_max_bosses[i]==res[i][ raidsDiffs[j] ] and "00ff00" or "ff0000",res[i][ raidsDiffs[j] ],raids_max_bosses[i]) ,1,1,1)
				collect["raid"..i.."_"..j] = res[i][ raidsDiffs[j] ]
			else
				self:AddDoubleLine(raids[i].." "..raidsDiffsNames[j], "|cffff0000---",1,1,1)
				collect["raid"..i.."_"..j] = 0
			end
		end
	end
end)


local worldBosses = UnitLevel'player' <= 100 and {
	1452,
} or {
	1790,1774,1789,1795,1770,1769,1783,1749,1763,1756,1796,
}
local maxWorldBosses = 1

for i=1,#worldBosses do
	worldBosses[i] = EJ_GetEncounterInfo(worldBosses[i])
end

--[[
tinsert(ToDoFunc,function(self,collect)
	local res = {}
	local count = 0
	for i=1,GetNumSavedWorldBosses() do
		local instanceName, instanceID, instanceReset = GetSavedWorldBossInfo(i)
	
		local inArr = IsInArray(worldBosses,instanceName)
		if inArr then
			res[inArr] = true
			count = count + 1
		end
	end
	local bossStr = format("|cff%s%d/%d",count==maxWorldBosses and "00ff00" or "ff0000",count,maxWorldBosses)
	self:AddDoubleLine("World Bosses:", bossStr)
	collect.worldBoss = bossStr
	for i=1,#worldBosses do
		if res[i] then
			self:AddDoubleLine(worldBosses[i], res[i] and "|cff00ff00Done" or "|cffff0000---",1,1,1)
		end
	end
end)
]]

tinsert(ToDoFunc,function(self,collect)
	local bounties,_,lockedType = GetQuestBountyInfoForMapID(1007)
	
	if lockedType then
		self:AddDoubleLine("Bounty", "Quest not completed",nil,nil,nil,1,0,0)
		return	
	elseif not bounties or #bounties == 0 then
		self:AddDoubleLine("Bounty", "Done",nil,nil,nil,0,1,0)
		return
	end
	self:AddLine("Bounty:")
	
	for i=1,#bounties do
		local d = bounties[i]
		local factionName = GetFactionInfoByID(d.factionID)
		
		local questIndex = GetQuestLogIndexByID(d.questID)
		if questIndex > 0 then
			local title, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID, startEvent, displayQuestID, isOnMap, hasLocalPOI, isTask, isBounty, isStory = GetQuestLogTitle(questIndex)
			if title then
				factionName = title
			end
		end
		
		local currQ, maxQ = 0,0
		
		for objectiveIndex = 1, d.numObjectives do
			local objectiveText, objectiveType, finished, numFulfilled, numRequired = GetQuestObjectiveInfo(d.questID, objectiveIndex, false)
			
			currQ = numFulfilled
			maxQ = numRequired
		end
		local fNameStr1 = "|T"..d.icon..":0|t "
		local fNameStr = fNameStr1..(factionName or "")
		local bountyStr = format("|cff%s%d/%d",currQ==maxQ and "00ff00" or "ff0000",currQ,maxQ)
		self:AddDoubleLine(fNameStr, bountyStr,1,1,1)
		
		local diff = C_TaskQuest.GetQuestTimeLeftMinutes(d.questID)
	
		if diff then
			local strDiff = format("%dh %dm",(diff / 60) % 24,diff % 60)
			if diff >= 1440 then
				strDiff = floor(diff / 1440).."d "..strDiff
			end
		
			self:AddDoubleLine("         Reset in",strDiff,1,1,1)
		
			collect["bounty"..i] = fNameStr1.." "..bountyStr
			collect["bounty"..i.."end"] = time() + diff * 60
		end
	end
end)

tinsert(ToDoFunc,function(self,collect)
	local artifactItemID, _, _, _, artifactTotalXP, artifactPointsSpent, _, _, _, _, _, _, artifactTier = C_ArtifactUI.GetEquippedArtifactInfo()

	collect.artifact = nil
	if artifactItemID then
		collect.artifact = artifactPointsSpent

		local numPointsAvailableToSpend, xp, xpForNextPoint = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(artifactPointsSpent, artifactTotalXP, artifactTier)
		if xpForNextPoint and xpForNextPoint ~= 0 then
			collect.artifact = (numPointsAvailableToSpend == 0 and "|cffffffff" or "|cffff0000")..(artifactPointsSpent + numPointsAvailableToSpend) .. "|r |cff888888("..floor(xp / xpForNextPoint * 100).."%)"
		end
	end
end)

local inspectScantip = CreateFrame("GameTooltip", "LegToDoScanningTooltip", nil, "GameTooltipTemplate")
inspectScantip:SetOwner(UIParent, "ANCHOR_NONE")

tinsert(ToDoFunc,function(self,collect)
	local keyInBags = GetItemCount(138019,true,false)

	local key = nil
	if keyInBags > 0 then
		for bag=0,5 do
			for slot=1,36 do
				local texture, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue = GetContainerItemInfo(bag, slot)
	
				if itemLink and (itemLink:find("item:138019") or itemLink:find("keystone:")) then
					local deep = false
				
					inspectScantip:SetBagItem(bag, slot)
					if inspectScantip:NumLines() > 0 then
						local name = _G["LegToDoScanningTooltipTextLeft1"]:GetText()
						name = name:gsub("^[^:]+: ","")
						if name:find("Каражан") then
							name = name:gsub("^[^:]+: ","Кара: ")
						end
						local lvl = _G["LegToDoScanningTooltipTextLeft2"]:GetText()
						if lvl and lvl:find("Израсходован") then
							deep = true
							lvl = _G["LegToDoScanningTooltipTextLeft3"]:GetText()
						end
						if lvl then
							lvl = lvl:match(": (%d+)")
							if lvl then
								key = (deep and "|cffff0000" or "").. lvl .. ": " ..name
							end
						end
					end
					inspectScantip:ClearLines()
				end
			end
		end	
	end
	
	self:AddDoubleLine("Key", key or "---")
	collect.mkey = key
end)


tinsert(ToDoFunc,function(self,collect)
	local avgItemLevel, avgItemLevelEquipped = GetAverageItemLevel()
	
	local ilvlStr = format("|cff%s%.1f|r",avgItemLevelEquipped >= 938 and "00ff00" or avgItemLevelEquipped >= 930 and "ffff00" or "ff0000",avgItemLevelEquipped)

	collect.ilvl = ilvlStr
	self:AddDoubleLine("iLvl", ilvlStr,nil,nil,nil,1,1,1)
end)


local firstInvasion = 1491375600
tinsert(ToDoFunc,function(self,collect)
	local curr = time()
	local next = firstInvasion
	
	while curr > next do
		next = next + 60 * 60 * 18.5
	end

	self:AddDoubleLine("Next Invasion", date("%d.%m.%Y %H:%M",next),nil,nil,nil,1,1,1)
end)

tinsert(ToDoFunc,function(self,collect)
	collect.gold = GetMoney()
end)


local MiniMapIcon = CreateFrame("Button", "LibDBIcon10_LegionToDoMinimap", Minimap)
MiniMapIcon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight") 
MiniMapIcon:SetSize(32,32) 
MiniMapIcon:SetFrameStrata("MEDIUM")
MiniMapIcon:SetFrameLevel(8)
MiniMapIcon:SetPoint("CENTER", 80, -12)
MiniMapIcon:SetDontSavePosition(true)
MiniMapIcon:RegisterForDrag("LeftButton")
MiniMapIcon.icon = MiniMapIcon:CreateTexture(nil, "BACKGROUND")
MiniMapIcon.icon:SetTexture(1035049)
MiniMapIcon.icon:SetSize(20,20)
MiniMapIcon.icon:SetPoint("CENTER", 0, 0)
MiniMapIcon.border = MiniMapIcon:CreateTexture(nil, "ARTWORK")
MiniMapIcon.border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
MiniMapIcon.border:SetTexCoord(0,0.6,0,0.6)
MiniMapIcon.border:SetAllPoints()
MiniMapIcon:RegisterForClicks("anyUp")
MiniMapIcon:SetScript("OnEnter",function(self) 
	local guid = UnitGUID("player")
	local charData = VLegionToDo.chars[guid]
	if not charData then
		charData = {}
		VLegionToDo.chars[guid] = charData
	end
	if not charData.s then
		charData.s = {}
	end
	local saved = charData.s
	wipe(charData)
	charData.s = saved
	charData.t = time()

	local realmKey = GetRealmName() or ""
	local charName = UnitName'player' or ""

	charData.name = charName
	charData.realm = realmKey
	charData.class = select(2,UnitClass("player"))

	RequestRaidInfo()

	GameTooltip:SetOwner(self, "ANCHOR_LEFT") 
	GameTooltip:AddLine("Legion ToDo") 
	for _,func in pairs(ToDoFunc) do
		func(GameTooltip,charData)
	end
	GameTooltip:Show() 
end)
MiniMapIcon:SetScript("OnLeave", function(self)    
	GameTooltip:Hide()
end)

local minimapShapes = {
	["ROUND"] = {true, true, true, true},
	["SQUARE"] = {false, false, false, false},
	["CORNER-TOPLEFT"] = {false, false, false, true},
	["CORNER-TOPRIGHT"] = {false, false, true, false},
	["CORNER-BOTTOMLEFT"] = {false, true, false, false},
	["CORNER-BOTTOMRIGHT"] = {true, false, false, false},
	["SIDE-LEFT"] = {false, true, false, true},
	["SIDE-RIGHT"] = {true, false, true, false},
	["SIDE-TOP"] = {false, false, true, true},
	["SIDE-BOTTOM"] = {true, true, false, false},
	["TRICORNER-TOPLEFT"] = {false, true, true, true},
	["TRICORNER-TOPRIGHT"] = {true, false, true, true},
	["TRICORNER-BOTTOMLEFT"] = {true, true, false, true},
	["TRICORNER-BOTTOMRIGHT"] = {true, true, true, false},
}

local function IconMoveButton(self)
	if self.dragMode == "free" then
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", x, y)
		VLegionToDo.IconMiniMapLeft = x
		VLegionToDo.IconMiniMapTop = y
	else
		local mx, my = Minimap:GetCenter()
		local px, py = GetCursorPosition()
		local scale = Minimap:GetEffectiveScale()
		px, py = px / scale, py / scale
		
		local angle = math.atan2(py - my, px - mx)
		local x, y, q = math.cos(angle), math.sin(angle), 1
		if x < 0 then q = q + 1 end
		if y > 0 then q = q + 2 end
		local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
		local quadTable = minimapShapes[minimapShape]
		if quadTable[q] then
			x, y = x*80, y*80
		else
			local diagRadius = 103.13708498985 --math.sqrt(2*(80)^2)-10
			x = math.max(-80, math.min(x*diagRadius, 80))
			y = math.max(-80, math.min(y*diagRadius, 80))
		end
		self:ClearAllPoints()
		self:SetPoint("CENTER", Minimap, "CENTER", x, y)
		VLegionToDo.IconMiniMapLeft = x
		VLegionToDo.IconMiniMapTop = y
	end
end

MiniMapIcon:SetScript("OnDragStart", function(self)
	self:LockHighlight()
	self:SetScript("OnUpdate", IconMoveButton)
	self.isMoving = true
	GameTooltip:Hide()
end)
MiniMapIcon:SetScript("OnDragStop", function(self)
	self:UnlockHighlight()
	self:SetScript("OnUpdate", nil)
	self.isMoving = false
end)

local function OnCloseFrame_Func()
	if InCombatLockdown() then
		return
	elseif not GameMenuFrame:IsVisible() then
		return
	end
	MiniMapIcon:GetScript("OnEnter")(MiniMapIcon)
	MiniMapIcon:GetScript("OnLeave")(MiniMapIcon)
end

local OnCloseFrame = CreateFrame("Frame",nil,GameMenuFrame)
OnCloseFrame:SetPoint("TOPLEFT")
OnCloseFrame:SetSize(1,1)
OnCloseFrame:SetScript("OnShow",function()
	C_Timer.After(.2,OnCloseFrame_Func)
end)

local LegionToDo = CreateFrame("Frame","LegionToDoFrame",UIParent)
LegionToDo:RegisterEvent("ADDON_LOADED")
LegionToDo:RegisterEvent("PLAYER_ENTERING_WORLD")
LegionToDo:RegisterEvent("UPDATE_INSTANCE_INFO")
LegionToDo:SetScript("OnEvent",function(self,event)
	if event == "PLAYER_ENTERING_WORLD" then
		RequestRaidInfo()
		C_Garrison.RequestLandingPageShipmentInfo()
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	elseif event == "UPDATE_INSTANCE_INFO" then
		C_Timer.After(1, function()
			self:UnregisterEvent("UPDATE_INSTANCE_INFO")
			MiniMapIcon:GetScript("OnEnter")(MiniMapIcon)
			MiniMapIcon:GetScript("OnLeave")(MiniMapIcon)
		end)
	elseif event == "ADDON_LOADED" then
		self:UnregisterEvent("ADDON_LOADED")
		
		VLegionToDo = VLegionToDo or {}
		VLegionToDo.chars = VLegionToDo.chars or {}
		VLegionToDo.black = VLegionToDo.black or {}
		VLegionToDo.opt = VLegionToDo.opt or {
			amana = true,
			warmy = true,
			gold = true,
			instance1 = true,
			instance2 = true,
			instance3 = true,
			instance4 = true,
			instance5 = true,
			instance6 = true,
			instance7 = true,
			instance8 = true,
			instance9 = true,
			instance10 = true,
			instance11 = true,
			instance12 = true,
			instance13 = true,
			raid1diff1 = true,
			raid1diff2 = true,
			raid1diff3 = true,
			raid2diff1 = true,
			raid2diff2 = true,
			raid2diff3 = true,
			raid3diff1 = true,
			raid3diff2 = true,
			raid3diff3 = true,
			raid4diff1 = true,
			raid4diff2 = true,
			raid4diff3 = true,
			raid5short = true,
		}
		
		VLegionToDo.ver = VERSION_NUMERIC
		
		if VLegionToDo.IconMiniMapLeft and VLegionToDo.IconMiniMapTop then
			MiniMapIcon:ClearAllPoints()
			MiniMapIcon:SetPoint("CENTER", VLegionToDo.IconMiniMapLeft, VLegionToDo.IconMiniMapTop)
		end
	end
end)
LegionToDo:Hide()
LegionToDo:SetPoint("CENTER")

tinsert(UISpecialFrames, "LegionToDoFrame")

LegionToDo:EnableMouse(true)
LegionToDo:SetMovable(true)
LegionToDo:RegisterForDrag("LeftButton")
LegionToDo:SetScript("OnDragStart", function(self)
	if self:IsMovable() then
		self:StartMoving()
	end
end)
LegionToDo:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
end)

LegionToDo:SetFrameStrata("DIALOG")

local LINE_WIDTH = 230

LegionToDo.f = CreateFrame("ScrollFrame", nil, LegionToDo)
LegionToDo.c = CreateFrame("Frame", nil, LegionToDo.f) 
LegionToDo.f:SetScrollChild(LegionToDo.c)
LegionToDo.f:SetClipsChildren(true)

LegionToDo.c:SetSize(1000,1000)

LegionToDo.f:SetPoint("TOPLEFT",0,-35)
LegionToDo.f:SetPoint("BOTTOMRIGHT",0,5)


LegionToDo.f1 = CreateFrame("ScrollFrame", nil, LegionToDo)
LegionToDo.c1 = CreateFrame("Frame", nil, LegionToDo.f1) 
LegionToDo.f1:SetScrollChild(LegionToDo.c1)
LegionToDo.f1:SetClipsChildren(true)

LegionToDo.c1:SetSize(1000,1000)

LegionToDo.f1:SetPoint("BOTTOMRIGHT",LegionToDo,"TOPRIGHT",0,-35)
LegionToDo.f1:SetPoint("TOPLEFT",LegionToDo,LINE_WIDTH,-5)


LegionToDo.f2 = CreateFrame("ScrollFrame", nil, LegionToDo.c)
LegionToDo.c2 = CreateFrame("Frame", nil, LegionToDo.f2) 
LegionToDo.f2:SetScrollChild(LegionToDo.c2)
LegionToDo.f2:SetClipsChildren(true)

LegionToDo.c2:SetSize(1000,1000)

LegionToDo.f2:SetPoint("TOPLEFT",LegionToDo.c,"TOPLEFT",LINE_WIDTH,0)
LegionToDo.f2:SetSize(1000,1000)

LegionToDo.b = LegionToDo:CreateTexture(nil,"BACKGROUND")
LegionToDo.b:SetAllPoints()
--LegionToDo.b:SetColorTexture(0,0,0,.9)
LegionToDo.b:SetColorTexture(0.04,0.04,0.04,.9)

LegionToDo.backdrop = CreateFrame("Frame",nil,LegionToDo)
LegionToDo.backdrop:SetPoint("TOPLEFT",-4,4)
LegionToDo.backdrop:SetPoint("BOTTOMRIGHT",4,-4)
--LegionToDo.backdrop:SetBackdrop({edgeFile="Interface/Tooltips/UI-Tooltip-Border",tile=false,edgeSize=14,insets={left=2.5,right=2.5,top=2.5,bottom=2.5}})

LegionToDo.shadow = CreateFrame("Frame",nil,LegionToDo)
do
	local size,edgeSize = 20,28
	LegionToDo.shadow:SetPoint("LEFT",-size,0)
	LegionToDo.shadow:SetPoint("RIGHT",size,0)
	LegionToDo.shadow:SetPoint("TOP",0,size)
	LegionToDo.shadow:SetPoint("BOTTOM",0,-size)
	LegionToDo.shadow:SetBackdrop({edgeFile="Interface/AddOns/"..GlobalAddonName.."/shadow",edgeSize=edgeSize or 28,insets={left=size,right=size,top=size,bottom=size}})
	LegionToDo.shadow:SetBackdropBorderColor(0,0,0,.45)
end

local CreateCheckBox,CreateBorder
do
	local function SetBorderColor(self,colorR,colorG,colorB,colorA,layerCounter)
		layerCounter = layerCounter or ""
		
		self["border_top"..layerCounter]:SetColorTexture(colorR,colorG,colorB,colorA)
		self["border_bottom"..layerCounter]:SetColorTexture(colorR,colorG,colorB,colorA)
		self["border_left"..layerCounter]:SetColorTexture(colorR,colorG,colorB,colorA)
		self["border_right"..layerCounter]:SetColorTexture(colorR,colorG,colorB,colorA)
	end
	local function ELib_Border(parent,size,colorR,colorG,colorB,colorA,outside,layerCounter)
		outside = outside or 0
		layerCounter = layerCounter or ""
		if size == 0 then
			if parent["border_top"..layerCounter] then
				parent["border_top"..layerCounter]:Hide()
				parent["border_bottom"..layerCounter]:Hide()
				parent["border_left"..layerCounter]:Hide()
				parent["border_right"..layerCounter]:Hide()
			end
			return
		end
		
		local textureOwner = parent.CreateTexture and parent or parent:GetParent()
		
		local top = parent["border_top"..layerCounter] or textureOwner:CreateTexture(nil, "BORDER")
		local bottom = parent["border_bottom"..layerCounter] or textureOwner:CreateTexture(nil, "BORDER")
		local left = parent["border_left"..layerCounter] or textureOwner:CreateTexture(nil, "BORDER")
		local right = parent["border_right"..layerCounter] or textureOwner:CreateTexture(nil, "BORDER")

		parent["border_top"..layerCounter] = top
		parent["border_bottom"..layerCounter] = bottom
		parent["border_left"..layerCounter] = left
		parent["border_right"..layerCounter] = right
	
		top:ClearAllPoints()
		bottom:ClearAllPoints()
		left:ClearAllPoints()
		right:ClearAllPoints()
		
		top:SetPoint("TOPLEFT",parent,"TOPLEFT",-size-outside,size+outside)
		top:SetPoint("BOTTOMRIGHT",parent,"TOPRIGHT",size+outside,outside)
	
		bottom:SetPoint("BOTTOMLEFT",parent,"BOTTOMLEFT",-size-outside,-size-outside)
		bottom:SetPoint("TOPRIGHT",parent,"BOTTOMRIGHT",size+outside,-outside)
	
		left:SetPoint("TOPLEFT",parent,"TOPLEFT",-size-outside,outside)
		left:SetPoint("BOTTOMRIGHT",parent,"BOTTOMLEFT",-outside,-outside)
	
		right:SetPoint("TOPLEFT",parent,"TOPRIGHT",outside,outside)
		right:SetPoint("BOTTOMRIGHT",parent,"BOTTOMRIGHT",size+outside,-outside)
	
		top:SetColorTexture(colorR,colorG,colorB,colorA)
		bottom:SetColorTexture(colorR,colorG,colorB,colorA)
		left:SetColorTexture(colorR,colorG,colorB,colorA)
		right:SetColorTexture(colorR,colorG,colorB,colorA)
		
		parent.SetBorderColor = SetBorderColor
	
		top:Show()
		bottom:Show()
		left:Show()
		right:Show()
	end
	ELib_Border(LegionToDo,1,.3,.3,.3,1)
	
	CreateBorder = ELib_Border
	
	function CreateCheckBox(parent)
		local self = CreateFrame("CheckButton",nil,parent)
		self:SetSize(20,20)
		
		self.text = self:CreateFontString(nil,"ARTWORK","GameFontNormalSmall")
		self.text:SetPoint("TOPLEFT",self,"TOPRIGHT",4,0)
		self.text:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT",4,0)
		self.text:SetJustifyV("MIDDLE")
		
		self:SetFontString(self.text)
		
		ELib_Border(self,1,0.24,0.25,0.3,1)
		
		self.Texture = self:CreateTexture(nil,"BACKGROUND")
		self.Texture:SetColorTexture(0,0,0,.3)
		self.Texture:SetPoint("TOPLEFT")
		self.Texture:SetPoint("BOTTOMRIGHT")
		
		self.CheckedTexture = self:CreateTexture()
		self.CheckedTexture:SetTexture("Interface\\Buttons\\UI-CheckBox-Check")
		self.CheckedTexture:SetPoint("TOPLEFT",-4,4)
		self.CheckedTexture:SetPoint("BOTTOMRIGHT",4,-4)
		self:SetCheckedTexture(self.CheckedTexture)
		
		self.PushedTexture = self:CreateTexture()
		self.PushedTexture:SetTexture("Interface\\Buttons\\UI-CheckBox-Check")
		self.PushedTexture:SetPoint("TOPLEFT",-4,4)
		self.PushedTexture:SetPoint("BOTTOMRIGHT",4,-4)
		self.PushedTexture:SetVertexColor(0.8,0.8,0.8,0.5)
		self.PushedTexture:SetDesaturated(true)
		self:SetPushedTexture(self.PushedTexture)
	
		self.DisabledTexture = self:CreateTexture()
		self.DisabledTexture:SetTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled")
		self.DisabledTexture:SetPoint("TOPLEFT",-4,4)
		self.DisabledTexture:SetPoint("BOTTOMRIGHT",4,-4)
		self:SetDisabledTexture(self.DisabledTexture)
			
		self.HighlightTexture = self:CreateTexture()
		self.HighlightTexture:SetColorTexture(1,1,1,.3)
		self.HighlightTexture:SetPoint("TOPLEFT")
		self.HighlightTexture:SetPoint("BOTTOMRIGHT")
		self:SetHighlightTexture(self.HighlightTexture)
				
		return self
	end
end

LegionToDo.leftScrollBar = CreateFrame("Slider", nil, LegionToDo)
LegionToDo.leftScrollBar:SetPoint("TOPLEFT",LegionToDo,1,-10)
LegionToDo.leftScrollBar:SetPoint("BOTTOMLEFT",LegionToDo,1,10)
LegionToDo.leftScrollBar:SetWidth(14)

LegionToDo.leftScrollBar.thumb = LegionToDo.leftScrollBar:CreateTexture(nil, "OVERLAY")
LegionToDo.leftScrollBar.thumb:SetColorTexture(0.44,0.45,0.50,.7)
LegionToDo.leftScrollBar.thumb:SetSize(10,20)

LegionToDo.leftScrollBar:SetThumbTexture(LegionToDo.leftScrollBar.thumb)
LegionToDo.leftScrollBar:SetOrientation("VERTICAL")
LegionToDo.leftScrollBar:SetMinMaxValues(0,100)
LegionToDo.leftScrollBar:SetValue(0)

LegionToDo.leftScrollBar.border = LegionToDo.leftScrollBar:CreateTexture(nil, "BORDER")
LegionToDo.leftScrollBar.border:SetColorTexture(.24,.25,.30,1)
LegionToDo.leftScrollBar.border:SetWidth(1)
LegionToDo.leftScrollBar.border:SetPoint("TOP",LegionToDo)
LegionToDo.leftScrollBar.border:SetPoint("BOTTOM",LegionToDo)
LegionToDo.leftScrollBar.border:SetPoint("LEFT",LegionToDo.leftScrollBar,"RIGHT")

LegionToDo.leftScrollBar:SetScript("OnValueChanged",function(self,value)
	LegionToDo.f:SetVerticalScroll(value) 
end)

LegionToDo.leftScrollBar:Hide()



LegionToDo.bottomScrollBar = CreateFrame("Slider", nil, LegionToDo)
LegionToDo.bottomScrollBar:SetPoint("BOTTOMLEFT",LegionToDo,10,-1)
LegionToDo.bottomScrollBar:SetPoint("BOTTOMRIGHT",LegionToDo,-10,-1)
LegionToDo.bottomScrollBar:SetHeight(14)

LegionToDo.bottomScrollBar.thumb = LegionToDo.bottomScrollBar:CreateTexture(nil, "OVERLAY")
LegionToDo.bottomScrollBar.thumb:SetColorTexture(0.44,0.45,0.50,.7)
LegionToDo.bottomScrollBar.thumb:SetSize(20,10)

LegionToDo.bottomScrollBar:SetThumbTexture(LegionToDo.bottomScrollBar.thumb)
LegionToDo.bottomScrollBar:SetOrientation("HORIZONTAL")
LegionToDo.bottomScrollBar:SetMinMaxValues(0,100)
LegionToDo.bottomScrollBar:SetValue(0)

LegionToDo.bottomScrollBar.border = LegionToDo.bottomScrollBar:CreateTexture(nil, "BORDER")
LegionToDo.bottomScrollBar.border:SetColorTexture(.24,.25,.30,1)
LegionToDo.bottomScrollBar.border:SetHeight(1)
LegionToDo.bottomScrollBar.border:SetPoint("LEFT",LegionToDo)
LegionToDo.bottomScrollBar.border:SetPoint("RIGHT",LegionToDo)
LegionToDo.bottomScrollBar.border:SetPoint("BOTTOM",LegionToDo.bottomScrollBar,"TOP")

LegionToDo.bottomScrollBar:SetScript("OnValueChanged",function(self,value)
	LegionToDo.f1:SetHorizontalScroll(value) 
	LegionToDo.f2:SetHorizontalScroll(value) 
end)

LegionToDo.bottomScrollBar:Hide()


LegionToDo:SetScript("OnMouseWheel", function (self,delta)
	if not LegionToDo.leftScrollBar:IsShown() then
		return
	end
	delta = delta * 20
	local min,max = LegionToDo.leftScrollBar:GetMinMaxValues()
	local val = LegionToDo.leftScrollBar:GetValue()
	if (val - delta) < min then
		LegionToDo.leftScrollBar:SetValue(min)
	elseif (val - delta) > max then
		LegionToDo.leftScrollBar:SetValue(max)
	else
		LegionToDo.leftScrollBar:SetValue(val - delta)
	end
end)


LegionToDo.Close = CreateFrame("Button",nil,LegionToDo,"UIPanelCloseButton")
LegionToDo.Close:SetPoint("TOPRIGHT",3,3)

LegionToDo.title = LegionToDo:CreateFontString(nil,"ARTWORK","GameFontWhite")
LegionToDo.title:SetPoint("TOPLEFT",30,-10)
LegionToDo.title:SetText("Legion ToDo "..VERSION)

local OPTIONS_TOGGLED = false

LegionToDo.Options = CreateFrame("Button",nil,LegionToDo)
LegionToDo.Options:SetPoint("TOPLEFT",130,0)
LegionToDo.Options:SetScript("OnClick",function(self)
	OPTIONS_TOGGLED = not OPTIONS_TOGGLED
	if OPTIONS_TOGGLED then
		self:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
		self:SetPushedTexture("Interface\\Buttons\\LockButton-Locked-Up")
	else
		self:SetNormalTexture("Interface\\Buttons\\LockButton-Locked-Up")
		self:SetPushedTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
	end
	LegionToDo:Hide()
	LegionToDo:Show()
end)
LegionToDo.Options:SetNormalTexture("Interface\\Buttons\\LockButton-Locked-Up")
LegionToDo.Options:SetPushedTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
LegionToDo.Options:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
LegionToDo.Options:SetSize(32, 32)

local CharsListDropdown = CreateFrame("Frame", "LegionToDoCharsListMenuFrame", LegionToDo, "UIDropDownMenuTemplate")

LegionToDo.CharsList = CreateFrame("Button",nil,LegionToDo,"UIPanelButtonTemplate")
LegionToDo.CharsList:SetPoint("TOPLEFT",160,-5)
LegionToDo.CharsList:SetScript("OnClick",function(self)
	if UIDROPDOWNMENU_OPEN_MENU then
		CloseDropDownMenus()
		return
	end
	local db = {}
	local list_realm = {}
	for guid,c in pairs(VLegionToDo.chars) do
		if not db[ c.realm ] then
			db[ c.realm ] = {}
			tinsert(list_realm,c.realm)
		end
		tinsert(db[c.realm],{c.name,guid})
	end
	sort(list_realm)
	local menuTable = {}
	for i=1,#list_realm do
		local list_chars = {}
		local realm = list_realm[i]
		sort(db[realm],function(a,b)return a[1]<b[1] end)
		for j=1,#db[realm] do
			local name,guid = db[realm][j][1],db[realm][j][2]
			list_chars[#list_chars + 1] = {
				text = name, 
				notCheckable = false, 
				keepShownOnClick = true,
				checked = function() 
					return not VLegionToDo.black[guid] 
				end,
				func = function()
					VLegionToDo.black[guid] = not VLegionToDo.black[guid] 
					UIDropDownMenu_RefreshAll(CharsListDropdown)
				end,
				--isNotRadio = true,
			}
		end
	
		menuTable[#menuTable + 1] = {
			hasArrow = true,
			menuList = list_chars,
			text = realm, 
			notCheckable = true, 
			keepShownOnClick = true,
		}
	end

	menuTable[#menuTable + 1] = {
		text = CLOSE, func = function() 
			CloseDropDownMenus() 
			LegionToDo:Hide()
			LegionToDo:Show()
		end, notCheckable = true
	}
	EasyMenu(menuTable, CharsListDropdown, "cursor", 10 , -15, "MENU")

end)
LegionToDo.CharsList:SetSize(22, 22)
LegionToDo.CharsList:SetText("C")

local function LineOnEnter(self)
	self.highlight:Show()
end
local function LineOnLeave(self)
	self.highlight:Hide()
end
local function LineCheckState(self,state)
	if state then
		self.check:Show()
		self.icon:SetPoint("LEFT",24,0)
	else
		self.check:Hide()
		self.icon:SetPoint("LEFT",4,0)
	end
end
local function LineCheckClick(self)
	VLegionToDo.opt[self.label or "tmp"] = not self:GetChecked()
end

local colNames = {}
local lines = {}

local linesPerRaids = #raids
for i=1,#raids do
	if not raids_short_format[i] then
		linesPerRaids = linesPerRaids - 1 + #raidsDiffs
	end
end

local function GetOrCreateLine(i)
	if not lines[i] then
		local line = CreateFrame("Frame",nil,LegionToDo.c)
		lines[i] = line
		line:SetPoint("TOPLEFT",0,-(i-1)*20 -0)
		line:SetPoint("BOTTOMRIGHT",LegionToDo.c,"TOPRIGHT",0,-i*20 -0)
		
		line.check = CreateCheckBox(line)
		line.check:SetPoint("LEFT",4,0)
		line.check:SetScript("OnClick",LineCheckClick)
		
		line.icon = line:CreateTexture(nil, "BACKGROUND")
		line.icon:SetPoint("LEFT",4,0)
		line.icon:SetSize(1,18)
	
		line.title = line:CreateFontString(nil,"ARTWORK","GameFontWhite")
		line.title:SetPoint("LEFT",line.icon,"RIGHT",1,0)
		line.title:SetPoint("RIGHT",line,"LEFT",LINE_WIDTH,0)
		line.title:SetHeight(18)
		line.title:SetJustifyH("LEFT")
		
		line.highlight = line:CreateTexture(nil, "BACKGROUND", nil, -5) 
		line.highlight:SetAllPoints()
		line.highlight:SetColorTexture(1,1,1,.15)
		line.highlight:Hide()
		
		line:SetScript("OnEnter",LineOnEnter)
		line:SetScript("OnLeave",LineOnLeave)
		
		line.UpdateCheck = LineCheckState
		
		line.cols = {}
	end
	return lines[i]
end

local function LineUpdate(pos,opt,text,icon,style)
	if not VLegionToDo.opt[opt] or OPTIONS_TOGGLED then
		pos = pos + 1
		local line = GetOrCreateLine(pos)
		line.title:SetText(text)
		line.check.label = opt
		line.check:SetChecked(not VLegionToDo.opt[opt])
		line:UpdateCheck(OPTIONS_TOGGLED)
		line.app = style
		if icon then
			line.icon:SetTexture(icon)
			line.icon:SetWidth(18)	
		else
			line.icon:SetTexture("")
			line.icon:SetWidth(1)			
		end
	end
	return pos
end

local LINES_MAX = 25
local COLS_MAX = 10

local hidden = {}

LegionToDo:SetScript("OnShow",function(self)
	local count = 0

	count = LineUpdate(count,"coins","Coins","Interface/Icons/inv_misc_elvencoins")
	count = LineUpdate(count,"orderres",GetCurrencyInfo(1220),"Interface/Icons/inv_orderhall_orderresources")

	local name, _, texturePath = GetCurrencyInfo(1342)
	count = LineUpdate(count,"warsupp",name,texturePath)

	local name, _, texturePath = GetCurrencyInfo(1226)
	count = LineUpdate(count,"nethershard",name,texturePath)

	local name, _, texturePath = GetCurrencyInfo(1155)
	count = LineUpdate(count,"amana",name,"Interface/Icons/inv_misc_ancient_mana")
		
	local name, _, texturePath = GetCurrencyInfo(1508)
	count = LineUpdate(count,"argunite",name,texturePath)
	
	count = LineUpdate(count,"argunitequest","Argunite quest")

	count = LineUpdate(count,"warmy","Withered Army Training")
	
	count = LineUpdate(count,"gold","Gold",nil,'small-left')	
	
	for i=1,#instancesInOptions do
		count = LineUpdate(count,"instance"..i,instances[ instancesInOptions[i] ])
	end
	
	count = LineUpdate(count,"mplusmax","Weekly max mythic+")
	
	count = LineUpdate(count,"garmisstos","ToS Garrison Mission",nil,'small')
	count = LineUpdate(count,"garmissabt","ABT Garrison Mission",nil,'small')
		
	for i=1,#raids do
		count = LineUpdate(count,"raid"..i.."short",raids[i])
		for j=1,#raidsDiffs do
			count = LineUpdate(count,"raid"..i.."diff"..j,raids[i].." "..raidsDiffsNames[j])
		end
	end
	
	for i=1,3 do
		count = LineUpdate(count,"bounty"..i,"Bounty #"..i)
	end
	
	count = LineUpdate(count,"artlvl","Aftifact LvL",nil,'center')
	count = LineUpdate(count,"mpluskey","Key",nil,'small')
	count = LineUpdate(count,"ilvl","Item Level",nil,'center')
	count = LineUpdate(count,"lastupate","Last Update",nil,'small')
	
	local sortedList = {}
	for guid,db in pairs(VLegionToDo.chars) do
		tinsert(sortedList,{guid,db,db.name})
	end	
	sort(sortedList,function(a,b)
		return a[3] < b[3]
	end)
	
	local curr = time()
	local playerGUID = UnitGUID'player'

	local col = 0
	for _,db_sorted in pairs(sortedList) do
		local guid = db_sorted[1]
		local db = db_sorted[2]
		if not hidden[guid] and (guid==playerGUID or not VLegionToDo.black[guid]) then
			col = col + 1
			
			for i=1,#lines do
				if not lines[i].cols[col] then
					local t = LegionToDo.c2:CreateFontString(nil,"ARTWORK","GameFontWhite")
					t:SetPoint("TOPLEFT",(col-1)*93,-(i-1)*20)
					t:SetSize(90,18)
					t:SetShadowColor(0,0,0)
					t:SetShadowOffset(1,-1)
					
					t.app = -1
					
					lines[i].cols[col] = t
				end
				
				local lineApp = lines[i].app			
				local t = lines[i].cols[col]
				if t.app ~= lineApp then
					if lineApp == 'small' then
						t:SetFont(t:GetFont(),10)
						t:SetSize(90,0)
						t:SetJustifyH("CENTER")
					elseif lineApp == 'small-left' then
						t:SetFont(t:GetFont(),10)
						t:SetSize(90,0)
						t:SetJustifyH("LEFT")
					elseif lineApp == 'center' then
						t:SetFont(GameFontWhite:GetFont())
						t:SetSize(90,18)
						t:SetJustifyH("CENTER")
					else
						t:SetFont(GameFontWhite:GetFont())
						t:SetSize(90,18)
						t:SetJustifyH("LEFT")
					end
					t.app = lineApp
				end
			end
			
			if not colNames[col] then
				colNames[col] = LegionToDo.c1:CreateFontString(nil,"ARTWORK","GameFontWhite")
				colNames[col]:SetPoint("TOPLEFT",(col-1)*93,0)
				colNames[col]:SetWidth(90)
				colNames[col]:SetJustifyH("CENTER")
				colNames[col]:SetFont(colNames[col]:GetFont(),10)
				
				local b = CreateFrame("Button",nil,LegionToDo)
				b:SetAllPoints(colNames[col])
				b.f = colNames[col]
				b:RegisterForClicks("AnyUp")
				b:SetScript("OnClick",function(s,b)
					local guidNow = s.f.guid
					local charName = db.name
					hidden[ guidNow ] = true
					if IsShiftKeyDown() or b == "RightButton" then
						StaticPopupDialogs["LEGIONTODO_HIDECHAR"] = {
							text = GetLocale() == "ruRU" and ("Скрыть персонажа "..charName..' навсегда?\nМожно будет вернуть его после сброса ("/ltd reset" или через меню ПКМ на иконке на миникарте)') or
								("Hide char "..charName..'?\nYou can get it back after reset ("/ltd reset" or via menu Right click on minimap icon)'),
							button1 = YES,
							button2 = NO,
							OnAccept = function()
								VLegionToDo.black[ guidNow ] = true
							end,
							timeout = 0,
							whileDead = true,
							hideOnEscape = true,
							preferredIndex = 3,
						}
						StaticPopup_Show("LEGIONTODO_HIDECHAR")					
					end
					LegionToDo:Hide()
					LegionToDo:Show()
				end)
			end
			
			colNames[col].guid = guid
			
			colNames[col]:SetText(db.name.."|n"..db.realm)
			local classColorArray = type(CUSTOM_CLASS_COLORS)=="table" and CUSTOM_CLASS_COLORS[db.class] or RAID_CLASS_COLORS[db.class]
			if classColorArray then
				colNames[col]:SetTextColor(classColorArray.r,classColorArray.g,classColorArray.b)
			else
				colNames[col]:SetTextColor(.8,.8,.8)
			end
			
			local D1 = date("*t")
			local needReset = false
			local thisThursday = (D1.wday > 4 or (D1.wday == 4 and D1.hour >= 9)) and time({day=D1.day - D1.wday + 4,month=D1.month,year=D1.year,hour=9}) or time({day=D1.day - D1.wday - 3,month=D1.month,year=D1.year,hour=9})
			
			if (db.t - thisThursday) < 0 then
				needReset = true
			end
			
			for i=1,#lines do
				lines[i].cols[col]:SetText("")
			end
	
			local lineCount = 0
			if not VLegionToDo.opt["coins"] or OPTIONS_TOGGLED then
				lineCount = lineCount + 1
				if needReset then
					lines[lineCount].cols[col]:SetText("|cffff00000/3"..(db.coinsNow and " ["..db.coinsNow.."]" or ""))
				else
					lines[lineCount].cols[col]:SetText(format("|cff%s%d/%d [%d%s]",db.coinsWeek==3 and "00ff00" or (db.coinsMax == db.coinsNow) and "ff8000" or "ff0000",db.coinsWeek or 0,3,db.coinsNow or 0,db.coinsMax == db.coinsNow and db.coinsMax and ",cap" or ""))
				end
			end
			
			if not VLegionToDo.opt["orderres"] or OPTIONS_TOGGLED then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.hallres or "0")
			end
			
			if not VLegionToDo.opt["warsupp"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.warsuppl or "0")
			end	
			
			if not VLegionToDo.opt["nethershard"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.nethershard or "0")
			end	
			
			if not VLegionToDo.opt["amana"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.amana or "0")
			end
			
			if not VLegionToDo.opt["argunite"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.argunite or "0")
			end		
			
			if not VLegionToDo.opt["argunitequest"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				if needReset then
					if db.arguniteQuest == true then
						lines[lineCount].cols[col]:SetText("|cffff0000Not done")
					else
						lines[lineCount].cols[col]:SetText(db.arguniteQuest and db.arguniteQuest ~= "0/50" and db.arguniteQuest or "|cffff0000-")
					end
				else
					if db.arguniteQuest == true then
						lines[lineCount].cols[col]:SetText("|cff00ff00Done")
					else
						lines[lineCount].cols[col]:SetText(db.arguniteQuest or "|cffff0000-")
					end			
				end
			end		
								
			if not VLegionToDo.opt["warmy"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				local wtraining = db.wtraining
				if db.wtrainingweek ~= floor((time() - witheredTrainingDay0) / days3val) then
					wtraining = nil
				end
				lines[lineCount].cols[col]:SetText(wtraining and "|cff00ff00Done" or "|cffff0000Not done")
			end
			
			if not VLegionToDo.opt["gold"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				if db.gold then
					lines[lineCount].cols[col]:SetText(GetCoinTextureString(db.gold - db.gold % 10000))
				end
			end		
			
			for i=1,#instancesInOptions do
				if not VLegionToDo.opt["instance"..i] or OPTIONS_TOGGLED  then
					lineCount = lineCount + 1
					if needReset then
						lines[lineCount].cols[col]:SetText("|cffff0000---")
					else
						lines[lineCount].cols[col]:SetText(db["instance"..instancesInOptions[i]] or "")
					end
				end
			end
			
			if not VLegionToDo.opt["mplusmax"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				if needReset then
					lines[lineCount].cols[col]:SetText("0")
				else
					lines[lineCount].cols[col]:SetText(db.weeklymax or "0")
				end
			end
			
			if not VLegionToDo.opt["garmisstos"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				local mission_tos = db.s and db.s.mission_tos
				if mission_tos then
					while mission_tos < curr do
						mission_tos = mission_tos + (13 * 24 * 60 * 60)
					end
					lines[lineCount].cols[col]:SetText(date("%d.%m.%Y %H:%M",mission_tos))
				end
			end	
			
			if not VLegionToDo.opt["garmissabt"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				local mission_abt = db.s and db.s.mission_abt
				if mission_abt then
					while mission_abt < curr do
						mission_abt = mission_abt + (13 * 24 * 60 * 60)
					end
					lines[lineCount].cols[col]:SetText(date("%d.%m.%Y %H:%M",mission_abt))
				end	
			end	
			
			for i=1,#raids do
				if not VLegionToDo.opt["raid"..i.."short"] or OPTIONS_TOGGLED  then
					lineCount = lineCount + 1
					local r = ""
					for j=1,#raidsDiffs do
						if needReset then
							r = r .. (j>1 and " - " or "").."|cffff00000|r"
						else
							local bossesDefeated = db["raid"..i.."_"..j] or 0
							if type(bossesDefeated)=='string' then
								bossesDefeated = tonumber( bossesDefeated:match("(%d+)/%d") or 0,nil ) or 0
							end
							r = r .. (j>1 and " - " or "").."|cff"..(bossesDefeated == raids_max_bosses[i] and "00ff00" or bossesDefeated == 0 and "ff0000" or "ffff00")..bossesDefeated.."|r"
						end
					end	
					lines[lineCount].cols[col]:SetText(r)	
				end		
				for j=1,#raidsDiffs do
					if not VLegionToDo.opt["raid"..i.."diff"..j] or OPTIONS_TOGGLED  then
						lineCount = lineCount + 1
						if needReset then
							lines[lineCount].cols[col]:SetText("|cffff00000/"..raids_max_bosses[i])
						else
							local bossesDefeated = db["raid"..i.."_"..j] or 0
							if type(bossesDefeated)=='string' then
								bossesDefeated = tonumber( bossesDefeated:match("(%d+)/%d") or 0,nil ) or 0
							end
							lines[lineCount].cols[col]:SetText("|cff"..(bossesDefeated == raids_max_bosses[i] and "00ff00" or bossesDefeated == 0 and "ff0000" or "ffff00")..bossesDefeated.."/"..raids_max_bosses[i])
						end
					end
				end
			end
			
			local currTime = time()
			for i=1,3 do
				if not VLegionToDo.opt["bounty"..i] or OPTIONS_TOGGLED  then
					lineCount = lineCount + 1
					local t = (db["bounty"..i] or ""):gsub(":0|t",":18|t")
					lines[lineCount].cols[col]:SetText(t)
					if db["bounty"..i.."end"] and db["bounty"..i.."end"] < currTime then
						local icon = t:gsub("|t.*$","|t")
						lines[lineCount].cols[col]:SetText(icon.." |cffffff00expired")
					end
				end
			end
			
			if not VLegionToDo.opt["artlvl"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.artifact or "")
			end	

			if not VLegionToDo.opt["mpluskey"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.mkey or "")
			end	

			if not VLegionToDo.opt["ilvl"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText(db.ilvl or "")
			end	

			if not VLegionToDo.opt["lastupate"] or OPTIONS_TOGGLED  then
				lineCount = lineCount + 1
				lines[lineCount].cols[col]:SetText((needReset and "|cffff0000" or "")..date("%d.%m.%Y %H:%M:%S",db.t))
			end	
		end
	end
	
	
	local isScrollShown = false
	if count > LINES_MAX then
		LegionToDo.f:SetPoint("TOPLEFT",16,-35)
		LegionToDo.f1:SetPoint("TOPLEFT",LegionToDo,LINE_WIDTH+16,-5)
		LegionToDo.leftScrollBar:Show()
		LegionToDo.leftScrollBar:SetMinMaxValues(0,(count - LINES_MAX) * 20)
		isScrollShown = true
	else
		LegionToDo.f:SetPoint("TOPLEFT",0,-35)
		LegionToDo.f1:SetPoint("TOPLEFT",LegionToDo,LINE_WIDTH,-5)
		LegionToDo.leftScrollBar:Hide()
		LegionToDo.f:SetVerticalScroll(0)
		LegionToDo.leftScrollBar:SetValue(0)
	end
	
	local isVScrollShown = false
	if col > COLS_MAX then
		LegionToDo.bottomScrollBar:Show()
		LegionToDo.f:SetPoint("BOTTOMRIGHT",0,5+16)
		LegionToDo.bottomScrollBar:SetMinMaxValues(0,(col - COLS_MAX) * 93)
		isVScrollShown = true
	else
		LegionToDo.bottomScrollBar:Hide()
		LegionToDo.f:SetPoint("BOTTOMRIGHT",0,5)
		LegionToDo.bottomScrollBar:SetValue(0)
	end
	
	LegionToDo:SetHeight(40 + 20*min(count,LINES_MAX) + (isVScrollShown and 16 or 0))
	LegionToDo.c:SetHeight(20 * count)
	LegionToDo.f2:SetHeight(20 * count)
	LegionToDo.c2:SetHeight(20 * count)
	
	LegionToDo:SetWidth(LINE_WIDTH + min(col,COLS_MAX)*93 + (isScrollShown and 16 or 0))
	LegionToDo.c:SetWidth(LINE_WIDTH+10+col * 93)
	LegionToDo.f2:SetWidth(col * 93)
	LegionToDo.c2:SetWidth(col * 93)
	
	for i=col+1,#colNames do
		colNames[i]:SetText("")
		for j=1,#lines do
			if lines[j].cols[i] then
				lines[j].cols[i]:SetText("")
			end
		end
	end
end)

local MiniMapDropdown = CreateFrame("Frame", "LegionToDoMiniMapMenuFrame", nil, "UIDropDownMenuTemplate")

local menuTable = {
	{ text = "Legion ToDo", func = function() 
		CloseDropDownMenus() 
		wipe(hidden)
		LegionToDo:Hide()	
		LegionToDo:Show()
	end, notCheckable = true },
	{ text = RESET, func = function() 
		CloseDropDownMenus() 
		wipe(VLegionToDo.black)
		LegionToDo:Hide()	
		LegionToDo:Show()
	end, notCheckable = true, tooltipOnButton = 1, tooltipTitle = GetLocale() == "ruRU" and "Вновь показать всех скрытых прежде персонажей" or "Show all hidden chars" },
	{ text = CLOSE, func = function() CloseDropDownMenus() end, notCheckable = true },
}

MiniMapIcon:SetScript("OnMouseUp", function (self, button)
	if button == "LeftButton" then
		wipe(hidden)
		if IsShiftKeyDown() then
			wipe(VLegionToDo.black)
		end
		LegionToDo:Show()
	else
		EasyMenu(menuTable, MiniMapDropdown, "cursor", 10 , -15, "MENU")
	end
end)

SlashCmdList["LTDSlash"] = function(arg)
	arg = arg:lower()
	if arg == "reset" then
		wipe(VLegionToDo.black)
		LegionToDo:Hide()
		LegionToDo:Show()
	else
		LegionToDo:Hide()
		LegionToDo:Show()		
	end
end
SLASH_LTDSlash1 = "/ltd"
SLASH_LTDSlash2 = "/legiontodo"